#!BPY

"""
Name: 'Array'
Blender: 232
Group: 'Mesh'
Tooltip: 'Array- you must select mesh object'
"""


#********Importovani Knihoven****
import whrandom
import math

import Blender 
from Blender import NMesh
from Blender.BGL import *
from Blender.Draw import *
#promenne
pole_rozmer_x=Create(1) 

#Events
EVENT_NOEVENT=1
EVENT_DRAW=2
EVENT_EXIT=3
EVENT_CIRCLE=4


#promenne pro slidery
pole_rozmer_x= Create(2)
pole_rozmer_y= Create(2)
pole_rozmer_z= Create(1)

pole_krok_x= Create(2.5)
pole_krok_y= Create(2.5)
pole_krok_z= Create(2.5)

pole_scale_x= Create(1.0)
pole_scale_y= Create(1.0)
pole_scale_z= Create(1.0)

pole_rot_x= Create(0)
pole_rot_y= Create(0)
pole_rot_z= Create(0)

pole_krok_rand_x= Create(0.0)
pole_krok_rand_y= Create(0.0)
pole_krok_rand_z= Create(0.0)

pole_scale_min_x= Create(1.0)
pole_scale_max_x= Create(1.0)
pole_scale_min_y= Create(1.0)
pole_scale_max_y= Create(1.0)
pole_scale_min_z= Create(1.0)
pole_scale_max_z= Create(1.0)

pole_rot_min_x= Create(0)
pole_rot_max_x= Create(0)
pole_rot_min_y= Create(0)
pole_rot_max_y= Create(0)
pole_rot_min_z= Create(0)
pole_rot_max_z= Create(0)


def funkce(test):
	for i in range(0,test):
		print i

def pole(pocet_x=3,pocet_y=3,pocet_z=3,krok_x=3,krok_y=3,krok_z=3,scale_x=1,scale_y=1,scale_z=1,rot_x=0,rot_y=0,rot_z=0,krok_rand_x=0,krok_rand_y=0,krok_rand_z=0,scale_rand_x_min=1.0,scale_rand_x_max=1.0,scale_rand_y_min=1.0,scale_rand_y_max=1.0,scale_rand_z_min=1.0,scale_rand_z_max=1.0,rot_rand_x_min=0,rot_rand_x_max=0,rot_rand_y_min=0,rot_rand_y_max=0,rot_rand_z_min=0,rot_rand_z_max=0):
	uhel_const=57.296
	whrandom.seed(2,3,4)
	try:
	  scene = Blender.Scene.getCurrent()
	  Ozero=Blender.Object.GetSelected()[0]
	  nomdelobjet=Ozero.getName()
	  Mesh=Blender.NMesh.GetRawFromObject(nomdelobjet)
	  for z in range (0,pocet_z):
		  for y in range (0,pocet_y):
			  for x in range (0,pocet_x):
				 #Prepocitani miry nahody pro offset
				 krok_rand_x2=krok_rand_x*whrandom.random()
				 krok_rand_y2=krok_rand_y*whrandom.random()
				 krok_rand_z2=krok_rand_z*whrandom.random()

				 #Prepocitani miry nahody pro rotaci
				 rot_rand_x2=(rot_rand_x_min+((rot_rand_x_max-rot_rand_x_min)*whrandom.random()))/uhel_const
				 rot_rand_y2=(rot_rand_y_min+((rot_rand_y_max-rot_rand_y_min)*whrandom.random()))/uhel_const
				 rot_rand_z2=(rot_rand_z_min+((rot_rand_z_max-rot_rand_z_min)*whrandom.random()))/uhel_const

				 #Prepocitani miry nahody pro zmenu velikosti
				 scale_rand_x2=scale_rand_x_min+((scale_rand_x_max-scale_rand_x_min)*whrandom.random())
				 scale_rand_y2=scale_rand_y_min+((scale_rand_y_max-scale_rand_y_min)*whrandom.random())
				 scale_rand_z2=scale_rand_z_min+((scale_rand_z_max-scale_rand_z_min)*whrandom.random())

			 
				 Obis = Blender.Object.New ('Mesh')
		 		 Obis.link(Mesh)
 				 Obis.setSize(Ozero.getSize()[0]*scale_x*scale_rand_x2,Ozero.getSize()[1]*scale_y*scale_rand_y2,Ozero.getSize()[2]*scale_z*scale_rand_z2)
 				 Obis.setEuler(Ozero.getEuler()[0]+rot_x/uhel_const+rot_rand_x2,Ozero.getEuler()[1]+rot_y/uhel_const+rot_rand_y2,Ozero.getEuler()[2]+rot_z/uhel_const+rot_rand_z2)
 		 	 	 Obis.setLocation(Ozero.getMatrix()[3][0]+krok_x*x+krok_rand_x2,Ozero.getMatrix()[3][1]+krok_y*y+krok_rand_y2,Ozero.getMatrix()[3][2]+krok_z*z+krok_rand_z2)
 		 		 scene.link (Obis) 
	  Blender.Redraw()
	except:
	  print "not a mesh or no object selected"

def kruh(pocet_x=3,pocet_y=3,pocet_z=3,krok_x=3,krok_y=3,krok_z=3,scale_x=1,scale_y=1,scale_z=1,rot_x=0,rot_y=0,rot_z=0,krok_rand_x=0,krok_rand_y=0,krok_rand_z=0,scale_rand_x_min=1.0,scale_rand_x_max=1.0,scale_rand_y_min=1.0,scale_rand_y_max=1.0,scale_rand_z_min=1.0,scale_rand_z_max=1.0,rot_rand_x_min=0,rot_rand_x_max=0,rot_rand_y_min=0,rot_rand_y_max=0,rot_rand_z_min=0,rot_rand_z_max=0):
	uhel_const=57.296
	whrandom.seed(2,3,4)
	try:
	  scene = Blender.Scene.getCurrent()
	  Ozero=Blender.Object.GetSelected()[0]
	  nomdelobjet=Ozero.getName()
	  Mesh=Blender.NMesh.GetRawFromObject(nomdelobjet)
	  for i2 in range(1,pocet_y):
		  for i in range(0,pocet_x):
		#Prepocitani miry nahody pro offset
#		krok_rand_x2=krok_rand_x*whrandom.random()
#		krok_rand_y2=krok_rand_y*whrandom.random()
#	 	krok_rand_z2=krok_rand_z*whrandom.random()

		#Prepocitani miry nahody pro rotaci
#		rot_rand_x2=(rot_rand_x_min+((rot_rand_x_max-rot_rand_x_min)*whrandom.random()))/uhel_const
#		rot_rand_y2=(rot_rand_y_min+((rot_rand_y_max-rot_rand_y_min)*whrandom.random()))/uhel_const
#		rot_rand_z2=(rot_rand_z_min+((rot_rand_z_max-rot_rand_z_min)*whrandom.random()))/uhel_const

     	#Prepocitani miry nahody pro zmenu velikosti
#		scale_rand_x2=scale_rand_x_min+((scale_rand_x_max-scale_rand_x_min)*whrandom.random())
#	    scale_rand_y2=scale_rand_y_min+((scale_rand_y_max-scale_rand_y_min)*whrandom.random())
#	    scale_rand_z2=scale_rand_z_min+((scale_rand_z_max-scale_rand_z_min)*whrandom.random())

		  	Obis = Blender.Object.New ('Mesh')
		  	Obis.link(Mesh)
 		  	Obis.setSize(Ozero.getSize()[0],Ozero.getSize()[1],Ozero.getSize()[2])
 		  	Obis.setLocation(Ozero.getMatrix()[3][0]+scale_x*math.sin(i)*krok_x*(i2*krok_y),Ozero.getMatrix()[3][1]+scale_y*math.cos(i)*krok_x*(i2*krok_y),Ozero.getMatrix()[3][2])
	 	  	scene.link (Obis) 

# 	  	Obis.setSize(Ozero.getSize()[0]*scale_x*scale_rand_x2,Ozero.getSize()[1]*scale_y*scale_rand_y2,Ozero.getSize()[2]*scale_z*scale_rand_z2)
# 	  	Obis.setEuler(Ozero.getEuler()[0]+rot_x/uhel_const+rot_rand_x2,Ozero.getEuler()[1]+rot_y/uhel_const+rot_rand_y2,Ozero.getEuler()[2]+rot_z/uhel_const+rot_rand_z2)
# 	  	Obis.setLocation(Ozero.getMatrix()[3][0]+krok_x*x+krok_rand_x2,Ozero.getMatrix()[3][1]+krok_y*y+krok_rand_y2,Ozero.getMatrix()[3][2]+krok_z*z+krok_rand_z2)

#	  for z in range (0,pocet_z):
#		  for y in range (0,pocet_y):
#			  for x in range (0,pocet_x):
#
			 
	  Blender.Redraw()
	except:
	  print "not a mesh or no object selected"



def draw():
	####Promenne pro offset tlacitek
	tlac_y=-20
	####promenne pro slidery
	global pole_rozmer_x,pole_rozmer_y,pole_rozmer_z,pole_krok_x,pole_krok_y,pole_krok_z,pole_scale_x,pole_scale_y,pole_scale_z,pole_rot_x,pole_rot_y,pole_rot_z,pole_krok_rand_x,pole_krok_rand_y,pole_krok_rand_z
	global pole_scale_min_x,pole_scale_max_x,pole_scale_min_y,pole_scale_max_y,pole_scale_min_z,pole_scale_max_z
	global pole_rot_min_x,pole_rot_max_x,pole_rot_min_y,pole_rot_max_y,pole_rot_min_z,pole_rot_max_z


	####Popisky
	glClear(GL_COLOR_BUFFER_BIT)
	glRasterPos2d(15,390+tlac_y)
	Text("You must select one mesh object to correct run script.")

	###Parametry GUI tlacitek
	glRasterPos2d(15,360+tlac_y)
	Text("Array size:			    		Offset:		    Size:			  Rot:")
	pole_rozmer_x= Number("Copies X:",EVENT_NOEVENT,10,335+tlac_y,120,18,pole_rozmer_x.val,1,200,"Count for number duplicate objects (X)");
	pole_rozmer_y= Number("Copies. Y:",EVENT_NOEVENT,10,315+tlac_y,120,18,pole_rozmer_y.val,1,200,"Toto cislo udava pocet rozkopirovanych objektu v ose Y");
	pole_rozmer_z= Number("Copies. Z:",EVENT_NOEVENT,10,295+tlac_y,120,18,pole_rozmer_z.val,1,200,"Toto cislo udava pocet rozkopirovanych objektu v ose Z");
	
	pole_krok_x= Number("X:",EVENT_NOEVENT,150,335+tlac_y,70,18,pole_krok_x.val,0,200,"Velikost posunu mezi objekty(=offset)");
	pole_krok_y= Number("Y:",EVENT_NOEVENT,150,315+tlac_y,70,18,pole_krok_y.val,0,200,"Velikost posunu mezi objekty(=offset)");
	pole_krok_z= Number("Z:",EVENT_NOEVENT,150,295+tlac_y,70,18,pole_krok_z.val,0,200,"Velikost posunu mezi objekty(=offset)");

	pole_scale_x= Number("X:",EVENT_NOEVENT,230,335+tlac_y,70,18,pole_scale_x.val,0,10,"Zmena velikosti duplikatu po ose X");
	pole_scale_y= Number("Y:",EVENT_NOEVENT,230,315+tlac_y,70,18,pole_scale_y.val,0,10,"Zmena velikosti duplikatu po ose Y");
	pole_scale_z= Number("Z:",EVENT_NOEVENT,230,295+tlac_y,70,18,pole_scale_z.val,0,10,"Zmena velikosti duplikatu po ose Z");

	pole_rot_x= Number("X:",EVENT_NOEVENT,310,335+tlac_y,70,18,pole_rot_x.val,0,360,"Zmena rotace duplikatu po ose X v uhlech");
	pole_rot_y= Number("Y:",EVENT_NOEVENT,310,315+tlac_y,70,18,pole_rot_y.val,0,360,"Zmena rotace duplikatu po ose Y v uhlech");
	pole_rot_z= Number("Z:",EVENT_NOEVENT,310,295+tlac_y,70,18,pole_rot_z.val,0,360,"Zmena rotace duplikatu po ose Z v uhlech");
	


#  *****Tlacitka pro randomize
	glRasterPos2d(15,260+tlac_y)
	Text("Randomize:")
	glRasterPos2d(15,240+tlac_y)
	Text("	                  Rand. Rot:	                        Rand. Offset:")
	glRasterPos2d(15,150+tlac_y)
	Text("	                  Rand. Size:")

	pole_krok_rand_x= Number("X:",EVENT_NOEVENT,270,215+tlac_y,70,18,pole_krok_rand_x.val,0,20,"Mira nahody pro posun podle osy X");
	pole_krok_rand_y= Number("Y:",EVENT_NOEVENT,270,195+tlac_y,70,18,pole_krok_rand_y.val,0,20,"Mira nahody pro posun podle osy Y");
	pole_krok_rand_z= Number("Z:",EVENT_NOEVENT,270,175+tlac_y,70,18,pole_krok_rand_z.val,0,20,"Mira nahody pro posun podle osy Z");
	
	pole_scale_min_x= Number("Min X:",EVENT_NOEVENT,20,125+tlac_y,100,18,pole_scale_min_x.val,0,360,"Mira nahody scale po ose X spodni hranice");
	pole_scale_max_x= Number("Max X:",EVENT_NOEVENT,140,125+tlac_y,100,18,pole_scale_max_x.val,0,360,"Mira nahody scale po ose X horni hranice");
	pole_scale_min_y= Number("Min Y:",EVENT_NOEVENT,20,105+tlac_y,100,18,pole_scale_min_y.val,0,360,"Mira nahody scale po ose Y spodni hranice");
	pole_scale_max_y= Number("Max Y:",EVENT_NOEVENT,140,105+tlac_y,100,18,pole_scale_max_y.val,0,360,"Mira nahody scale po ose Y horni hranice");
	pole_scale_min_z= Number("Min Z:",EVENT_NOEVENT,20,85+tlac_y,100,18,pole_scale_min_z.val,0,360,"Mira nahody scale po ose Z spodni hranice");
	pole_scale_max_z= Number("Max Z:",EVENT_NOEVENT,140,85+tlac_y,100,18,pole_scale_max_z.val,0,360,"Mira nahody scale po ose Z horni hranice");

	pole_rot_min_x= Number("Min X:",EVENT_NOEVENT,20,215+tlac_y,100,18,pole_rot_min_x.val,0,360,"Mira nahody rotace po ose X spodni hranice");
	pole_rot_max_x= Number("Max X:",EVENT_NOEVENT,140,215+tlac_y,100,18,pole_rot_max_x.val,0,360,"Mira nahody rotace po ose X horni hranice");
	pole_rot_min_y= Number("Min Y:",EVENT_NOEVENT,20,195+tlac_y,100,18,pole_rot_min_y.val,0,360,"Mira nahody rotace po ose Y spodni hranice");
	pole_rot_max_y= Number("Max Y:",EVENT_NOEVENT,140,195+tlac_y,100,18,pole_rot_max_y.val,0,360,"Mira nahody rotace po ose Y horni hranice");
	pole_rot_min_z= Number("Min Z:",EVENT_NOEVENT,20,175+tlac_y,100,18,pole_rot_min_z.val,0,360,"Mira nahody rotace po ose Z spodni hranice");
	pole_rot_max_z= Number("Max Z:",EVENT_NOEVENT,140,175+tlac_y,100,18,pole_rot_max_z.val,0,360,"Mira nahody rotace po ose Z horni hranice");

	###Nakreslit tlacitka
	Button("Make Array",EVENT_DRAW,20,10,80,18)
	Button("Circle",EVENT_CIRCLE,110,10,80,18)

	Button("Exit",EVENT_EXIT,270,10,80,18)

def event(evt,val):
	if(evt == QKEY and not val):
		Exit()

def bevent(evt):
	###Ovladani  GUI soucasti
	if(evt== EVENT_EXIT):
		Exit()
	if (evt==EVENT_DRAW):
		pole(pole_rozmer_x.val,pole_rozmer_y.val,pole_rozmer_z.val,pole_krok_x.val,pole_krok_y.val,pole_krok_z.val,pole_scale_x.val,pole_scale_y.val,pole_scale_z.val,pole_rot_x.val,pole_rot_y.val,pole_rot_z.val,pole_krok_rand_x.val,pole_krok_rand_y.val,pole_krok_rand_z.val,pole_scale_min_x.val,pole_scale_max_x.val,pole_scale_min_y.val,pole_scale_max_y.val,pole_scale_min_z.val,pole_scale_max_z.val,pole_rot_min_x.val,pole_rot_max_x.val,pole_rot_min_y.val,pole_rot_max_y.val,pole_rot_min_z.val,pole_rot_max_z.val)
		Blender.Redraw
	if (evt==EVENT_CIRCLE):
		kruh(pole_rozmer_x.val,pole_rozmer_y.val,pole_rozmer_z.val,pole_krok_x.val,pole_krok_y.val,pole_krok_z.val,pole_scale_x.val,pole_scale_y.val,pole_scale_z.val,pole_rot_x.val,pole_rot_y.val,pole_rot_z.val,pole_krok_rand_x.val,pole_krok_rand_y.val,pole_krok_rand_z.val,pole_scale_min_x.val,pole_scale_max_x.val,pole_scale_min_y.val,pole_scale_max_y.val,pole_scale_min_z.val,pole_scale_max_z.val,pole_rot_min_x.val,pole_rot_max_x.val,pole_rot_min_y.val,pole_rot_max_y.val,pole_rot_min_z.val,pole_rot_max_z.val)
		Blender.Redraw


Register(draw,event,bevent)